package com.tanpu.community.api.beans.qo;


import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

@Data
@Builder
@AllArgsConstructor
@NoArgsConstructor
public class ThemeAnalysDO {

    private static final long serialVersionUID = 1L;


    @ApiModelProperty(value = "主题Id")
    private String themeId;

    @ApiModelProperty(value = "作者id")
    private String authorId;

    @ApiModelProperty(value = "被转发的主题")
    private String formerThemeId;

    @ApiModelProperty(value = "所属的话题")
    private String topicId;

    @ApiModelProperty(value = "转发量")
    private Integer forwardCount;

    @ApiModelProperty(value = "评论量")
    private Integer commentCount;

    @ApiModelProperty(value = "点赞量")
    private Integer likeCount;

    @ApiModelProperty(value = "收藏量")
    private Integer collectCount;

    @ApiModelProperty(value = "收藏量")
    private Integer viewCount;

    @ApiModelProperty(value = "距今时间")
    private Long minuteTillNow;

    @ApiModelProperty(value = "用户质量")
    private Double userWeight = 0.0;

    public Double getRank() {
        // 质量=帖子质量+用户质量
        double w = (double) (viewCount * 0.1 + forwardCount * 3 + commentCount * 2 + likeCount * 1 + collectCount * 3) + userWeight;
        double i = 1;//初试权重
        double t = Double.valueOf(minuteTillNow) / 60;
        double g = 0.1;//时间系数
        return (w + i) / Math.pow(t + 1, g);
    }

}
