package com.tanpu.community.api.beans.qo;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

@Data
@ApiModel("热点话题对象")
public class TopicRankQo {

    @ApiModelProperty(value = "话题ID")
    private String topicId;

    @ApiModelProperty(value = "话题名称")
    private String topicTitle;

    @ApiModelProperty(value = "类型 1：热 2：新")
    private Integer type;

    @ApiModelProperty(value = "阅读量")
    private Integer viewCount;

    @ApiModelProperty(value = "讨论量")
    private Integer disscussCount;

    @ApiModelProperty(value = "阅读量-格式化")
    private String formatViewCount;

    @ApiModelProperty(value = "讨论量-格式化")
    private String formatDisscussCount;

    @ApiModelProperty(value = "是否置顶")
    private Integer isTop;

    @ApiModelProperty(value = "浏览量调整基数")
    private Integer viewCntAdjust;

    @ApiModelProperty(value = "话题下的帖子权重")
    private Double themeWeight;

    private Integer hoursTillNow;


    /**
     * 热度计算算法
     *
     * @return
     */
    public Double getRank() {
        double g = 0.3;//时间系数
        //顶置话题
        if (isTop > 0) {
            return Double.MAX_VALUE;
        }
        Double socre = ((disscussCount * 3 + viewCount) / Math.pow(hoursTillNow + 1, g)) + themeWeight;
        return socre;
    }
}
